// ***************************************************************
//  main   version:  1.0     date: 10/10/2007
//  -------------------------------------------------------------
//  Dijkstra_adjacency-list representation
//  -------------------------------------------------------------
//  Copyright FrozenFire(C) 2007 - All Rights Reserved
// ***************************************************************
//     ,    (   )
//      ,  0 - , 1 - , 
//       (0,0)  (x, y),  x  y -  
// ***************************************************************

#include<vector>
#include<iostream>
#include<fstream>
#include<algorithm>
#include<windows.h>
using namespace std;

struct SEdge{
	int dataE;// 
	int numVertex;//   

	SEdge( int _dataE, int _vertex ) {
		dataE = _dataE;
		numVertex = _vertex;
	}
};
struct SVertex{
	int _from;//   
	int _path;//    
	WPARAM dataV;// 
	vector< SEdge > edge;//  

	SVertex( WPARAM _dataV ) {
		dataV = _dataV;
	}
	void AddEdge( int _dataE, int toNumVertex ) {
		for( size_t i = 0; i < edge.size(); ++i ) {
			if( edge[i].numVertex == toNumVertex ) {
				throw 0;
			}
		}
		edge.push_back( SEdge( _dataE, toNumVertex ) );
	}
	int FindNumEdge( int toNumVertex ) {
		for( int i = 0; i < (int)edge.size(); ++i ) {
			if( edge[i].numVertex == toNumVertex ) {
				return i;
			}
		}
		throw 0;
	}
	void DelEdge( int toNumVertex ) {
		for( int i = 0 ; i < (int)edge.size(); ++i ) {
			if( edge[i].numVertex == toNumVertex ) {
				edge.erase( edge.begin() + i );
				return;
			}
		}
		throw 0;
	}
};
struct SGraph {
	vector< SVertex > vertex;// 
	void AddVertex( WPARAM _dataV ) {
		for( size_t i = 0; i < vertex.size(); ++i ) {
			if( vertex[i].dataV == _dataV ) {
				throw 0;
			}
		}
		vertex.push_back( SVertex( _dataV ) );
	}
	int FindNumVertex( WPARAM _dataV ) {
		for( int i = 0; i < (int)vertex.size(); ++i ) {
			if( vertex[i].dataV == _dataV ) {
				return i;
			}
		}
		throw 0;
	}
	void AddEdge( WPARAM _dataV1, WPARAM _dataV2, int _dataE1, int _dataE2 = 0, bool revers = false ) {
		int from = FindNumVertex( _dataV1 );
		int to = FindNumVertex( _dataV2 );
		vertex[from].AddEdge( _dataE1, to );
		if( revers ) {
			vertex[to].AddEdge( _dataE2, from );
		}
	}
	void Dijkstra( WPARAM _dataV1, WPARAM _dataV2, vector< WPARAM > & path ) {
		int from = FindNumVertex( _dataV1 );
		int to = FindNumVertex( _dataV2 );

		InitializeSingleSourse( from );
		vector< int > vertexTemp;//  
		for( int i = 0; i < (int)vertex.size(); ++i ) {
			vertexTemp.push_back( i );
		}
		while( vertexTemp.size() ) {//  
			int minVertex = ExtractMin( vertexTemp );// 
			// ,     
			vector< SEdge > * edge = &vertex[minVertex].edge;
			for( int vertexTo = 0; vertexTo < (int)edge->size(); ++vertexTo ) {
				Relax( minVertex, vertexTo );
			}
		}
		for(; to != -1 ;) {
			path.push_back( vertex[to].dataV );
			to = vertex[to]._from;
		}
		reverse( path.begin(), path.end() );
	}
	int ExtractMin( vector< int > & vertexTemp ) {
		int minimum = INT_MAX;
		int numer = -1;
		int index = -1;
		for( int i = 0; i < (int)vertexTemp.size(); ++i ) {
			//    ?
			if( minimum > vertex[vertexTemp[i]]._path ) {
				minimum = vertex[vertexTemp[i]]._path;
				numer = vertexTemp[i];
				index = i;
			}
		}
		//  ..     
		if( index == -1 ) {
			throw 0;
		}
		vertexTemp.erase( vertexTemp.begin() + index );
		return numer;
	}
	void InitializeSingleSourse( int from ) {
		//""
		for( int i = 0 ; i < (int)vertex.size(); ++i ) {
			vertex[i]._path = INT_MAX;//
			vertex[i]._from = -1;// 
		}
		vertex[from]._path = 0;// 
	}
	void Relax( int from, int numEdge ) {
		//       
		int data = vertex[from].edge[numEdge].dataE;
		int to = vertex[from].edge[numEdge].numVertex;
		if( vertex[to]._path > vertex[from]._path + data ) {
			vertex[to]._path = vertex[from]._path + data;
			vertex[to]._from = from;
		}
	}
};

void init( int ** matrix, int x, int y, SGraph & g ) {
	//   ,  1   
	for( int j = 0; j < y; ++j ) {
		for( int i = 0; i < x; ++i ) {
			if( matrix[i][j] == 0 ) {
				if( i-1 >= 0 && j-1 >= 0 ) if( matrix[i-1][j-1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i-1, j-1 ), 1 );
				}
				if( j-1 >= 0 ) if( matrix[i][j-1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i, j-1 ), 1 );
				}
				if( i+1 < x && j-1 >= 0 ) if( matrix[i+1][j-1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i+1, j-1 ), 1 );
				}
				if( i+1 < x ) if( matrix[i+1][j] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i+1, j ), 1 );
				}
				if( i+1 < x && j+1 < y ) if( matrix[i+1][j+1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i+1, j+1 ), 1 );
				}
				if( j+1 < y ) if( matrix[i][j+1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i, j+1 ), 1 );
				}
				if( i-1 >= 0 && j+1 < y  ) if( matrix[i-1][j+1] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i-1, j+1 ), 1 );
				}
				if( i-1 >= 0 ) if( matrix[i-1][j] == 0 ) {
					g.AddEdge( MAKEWPARAM( i, j ), MAKEWPARAM( i-1, j ), 1 );
				}
			}
		}
	}
}
int main() {
	ofstream out( "output.txt" );
	ifstream in( "input.txt" );
	int x = 0;
	int y = 0;
	while( in ) {
		in >> x;
		in >> y;
		if( x == 0 || y == 0 ) {
			return 0;
		}
		SGraph g;
		vector< WPARAM > path;
		int ** matrix = new int* [x];
		for( int i = 0 ; i < x; ++i ) {
			matrix[i] = new int[y];
		}
		for( int j = 0 ; j < y; ++j ) {
			for( int i = 0 ; i < x; ++i ) {
				in >> matrix[i][j];
			//	cout << matrix[i][j];
				if( matrix[i][j] == 0 ) {
					// 
					g.AddVertex( MAKEWPARAM( i, j ) );
				}
			}
		//	cout << "\n";
		}
		init( matrix, x, y, g );
		try{
			g.Dijkstra( MAKEWPARAM( 0, 0 ), MAKEWPARAM( x-1, y-1 ), path );
			out << "good " << path.size() << "\n";
			for( int i = 0; i < (int)path.size(); ++i ) {
				out << "( " << (int) HIWORD( path[i] ) << ", ";
				out << (int)LOWORD( path[i] ) << " )\n";
			}
		}catch(...){
			out <<"error\n";
		}
		
		for( int i = 0 ; i < x; ++i ) {
			delete matrix[i];
		}
		delete matrix;
	}
	return 0;
}